//     AT90S2313//
//     //
//       //
//    AvrEdit Ver3.5 //
#include <inttypes.h>
#include <io.h>
#include <sig-avr.h>
#include <interrupt.h>
#include <stdlib.h>
#define key_1 0		//  1
#define key_2 1		//  2
#define key_3 2		//  3
#define led_1 4		//  1
#define out_1 3		// 
#define discret 20      // 
#define max_PWI 255     //   
#define min_PWI 15      //   
unsigned char paus, impuls;	//  

//--------------------------------------------------------------------------
//  t  10ms
//---------------------------------------------------------------------------
#define F_CPU 4000000
#define K_DELAY_10ms	F_CPU/600
void Delay_10ms(unsigned char t) {
  unsigned int i;
  if (t==0) return;
  while (t--) for(i=0;i<K_DELAY_10ms; i++);
}



//--------------------------------------------------------------------------
//      0
//---------------------------------------------------------------------------
SIGNAL(SIG_OVERFLOW0) {
  	if (bit_is_set(PINB, out_1)) {	//   
	cbi(PORTB,out_1); 		// .0   
	TCNT0 =paus;			//   	
}
   	else {	
	sbi(PORTB,out_1); 		// .1   
	TCNT0 =impuls;			//   		
}
}


//--------------------------------------------------------------------------
//       "+"  "-".
//---------------------------------------------------------------------------
void pause(void) {
        sbi(PORTB,led_1);		// 
	Delay_10ms(50);			// 	
	cbi(PORTB,led_1);		// 
	Delay_10ms(50);			// 
}


//--------------------------------------------------------------------------
// 			 
//---------------------------------------------------------------------------
int main(void) {
unsigned char j;			// 
  	DDRB  =0x18;  			//    
  	PORTB =0x07;  			//   
	TCCR0=0x01;			//  0 (1:1)
	TIMSK=0x02;			//   0	
        impuls=0xff;			//    
        paus=0x00;			//    
        j=0;				//  
  while(1) {     			//   
//--------------------------------------------------------------------------
//        ,    ( )
//---------------------------------------------------------------------------
         j++;				//   (       /    j
	Delay_10ms(1);			// 
	if (j==1) sbi(PORTB,led_1);	// j=1,   
	if (j==20) cbi(PORTB,led_1);	// j=20,   
//--------------------------------------------------------------------------
//        .
//---------------------------------------------------------------------------
	if (bit_is_clear(PINB,key_1)) { //     1
	cbi(PORTB,led_1);  		//    
	sei();				//  ,   	
	while (bit_is_clear(PINB,key_1)); //   (      "./."
	Delay_10ms(200);		//  ,   
	while(1) {			//        
	if (bit_is_clear(PINB,key_2)) {	//     "-"
	if (impuls>min_PWI) {		// ,           
	paus=paus+discret; 			//  ,     
	impuls=impuls-discret;		//   
}
	pause();			//  
}
	if (bit_is_clear(PINB,key_3)) {	//     "+"
	if (impuls<max_PWI) {		// ,           
	paus=paus-discret; 			//  ,     
	impuls=impuls+discret;		//   
}
	pause();			//  
}
	if (bit_is_clear(PINB,key_1)) {	//     "./."
	cli(); 				// ,   ,   				
	cbi(PORTB,out_1);		//  
 	sbi(PORTB,led_1);		// 
	while (bit_is_clear(PINB,key_1));//      
	Delay_10ms(200);		//  ,   
        break;				// 
}
}
}
}
}
